import java.io.*;
import java.awt.*;
import VM.*;

class Util
{
	static class GoToCircleOrbit
	{
		int startTime;
		ClientBase cb;
		double end_r;
		double param1;
		public GoToCircleOrbit( int startTime, double end_r, double param1, ClientBase cb )
		{
			this.startTime = startTime;
			this.cb = cb;
			this.end_r = end_r;
			this.param1 = param1;
		}

		double start_r = 0;
		int Q = 0;
		public boolean doit( int t ) throws IOException
		{
			if( Q == 0 )
			{
				if( t < startTime )
					cb.step(0, 0);
				else
				if( t == startTime )
				{
					start_r  = cb.SR;
					double f = (Math.sqrt(end_r*2 / (end_r+start_r)) - 1) * cb.V;
					cb.step(cb.N_VX*f-cb.GX, cb.N_VY*f-cb.GY);
					Q = 1;
				}
				else
					cb.step(0, 0);
			}
			else if( Q == 1 )
			{
				if( cb.PR>cb.SR )
				{
					double v = Math.sqrt(cb.G*cb.ME / end_r);
					double f = (Math.sqrt(start_r*2 / (start_r+cb.SR)) - 1) * -v;
					cb.step((cb.N_VX*f-cb.GX*param1)/2, (cb.N_VY*f-cb.GY*param1)/2);
					Q = 2;
				}
				else
					cb.step(0, 0);
			}
			else if( Q == 2 )
			{
				double v = Math.sqrt(cb.G*cb.ME / end_r);
				double f = (Math.sqrt(start_r*2 / (start_r+cb.SR)) - 1) * -v;
				cb.step((cb.N_VX*f-cb.GX)/2, (cb.N_VY*f-cb.GY)/2);
				Q = 3;
			}
			else
				cb.step(0, 0);

			return Q==3;
		}
	}
}


public class Client2002 extends ClientBase implements GUI.Paintable
{
	public static void main(String[] arg) throws Exception { new Client2002().run(); }
	public Client2002() throws Exception { super(2002); }

	void run() throws IOException
	{
		step(0, 0);
		step(0, 0);

		Util.GoToCircleOrbit gc = new Util.GoToCircleOrbit(14352, TR, 2, this);
		for(int i=0;; ++i)
		{
			endgame_check(i);
			gc.doit(i);
			wait(10000);
		}
	}
}
