import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class GUI
{
	static interface Paintable
	{
		void paint( Graphics g );
	}

	public GUI( final Paintable pt )
	{
		JFrame f = new JFrame("Pepsiso!");
		f.setSize(600, 600);
		Container contentPane = f.getContentPane();
		contentPane.setLayout(new BorderLayout());

		final JPanel canv = new JPanel() {
			public void paintComponent(Graphics g) 
			{
				super.paintComponent(g);
				pt.paint(g);
			}
		};

		canv.setBackground(Color.white);
		contentPane.add(canv);
		f.setVisible(true);
		f.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

		new Timer(50, new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				canv.repaint();
			}
		}).start();
	}
}
