import java.io.*;
import java.awt.*;
import VM.*;

public class OsfViewer extends ClientBase implements GUI.Paintable
{
	public static void main( String[] arg ) throws Exception
	{
		if( arg.length == 0 )
		{
			System.out.println("Usage: java OsfViewer hoge.osf");
		}
		else
		{
			new OsfViewer( new FileInputStream(arg[0]) ).run();
		}
	}

	FileInputStream is;
	static int readHeader( FileInputStream is ) throws IOException {
		int n = readInt(is); // 0xCAFEBABE
		readInt(is); // team
		return readInt(is); // config
	}
	public OsfViewer( FileInputStream is ) throws Exception
	{
		super( readHeader(is), false );
		this.is = is;
	}

	static double readDouble(FileInputStream is) throws IOException
	{
		long L = readInt(is);
		long H = readInt(is);
		return Double.longBitsToDouble( L | (H<<32) );
	}

	static int readInt(FileInputStream is) throws IOException
	{
		int A = is.read();
		int B = is.read();
		int C = is.read();
		int D = is.read();
		return A | (B<<8) | (C<<16) | (D<<24);
	}

	void run() throws IOException
	{
		double p2=0, p3=0;
		try {
			for(;;)
			{
				int t = readInt(is);
				while( vm.getTimeStamp() < t )
				{
					wait(1000000);
					step(p2, p3);
				}
				int n = readInt(is);
				for(int i=0; i<n; ++i) {
					int p = readInt(is);
					double v = readDouble(is);
					if( p==2 ) p2 = v;
					else if( p==3 ) p3 = v;
				}
			}
		} catch( IOException e ) {}
		System.exit(0);
	}
}
