import java.io.*;
import VM.*;

public strictfp class <%CLASSNAME%> implements VM, Cloneable, Serializable
{
	// VM states
	private int timeStamp = 0;
	private boolean status    = false;
	private double mem[]      = new double[16384];
	private double port_in[]  = new double[16384];
	private double port_out[] = new double[16384];

	// in/out configurations
	private int config = 0;

	// VM interface implementation
	public int getConfigID()  { return config; }
	public int getTimeStamp() { return timeStamp; }
	public double readPort( int i ) { return port_out[i]; }
	public void step( double dvx, double dvy )
	{
		port_in[2]      = dvx;
		port_in[3]      = dvy;
		port_in[0x3E80] = config;
		vm_main();
		++timeStamp;
	}

	// initialization
	public <%CLASSNAME%>( int config ) throws IOException, FileNotFoundException
	{
		this.config = config;
		vm_init();
	}

	// clone
	public VM snapshot() { return new <%CLASSNAME%>(this); }
	private <%CLASSNAME%>( <%CLASSNAME%> orig )
	{
		this.timeStamp = orig.timeStamp;
		this.status    = orig.status;
		this.mem       = orig.mem.clone();
		this.port_in   = orig.port_in.clone();
		this.port_out  = orig.port_out.clone();
		this.config    = orig.config;
	}

	// memory initialization
	private void vm_init()
	{
<%VMINIT%>
	}

	// VM main loop
	void vm_main()
	{
<%VMMAIN%>
	}
}
